Верстак A2plus

From FreeCAD Documentation
Jump to navigation Jump to search
This page is a translated version of the page A2plus Workbench and the translation is 93% complete.
Other languages:
Deutsch • ‎English • ‎français • ‎italiano • ‎русский • ‎中文(简体)‎
A2plus workbench icon

Введение

Contents

Верстак A2plus - это внешний верстак для создания сборок деталей в FreeCAD.

Эта документация описывает версию A2plus 0.4.47 или новее.

Установка

Верстак A2plus - это дополнение к FreeCAD. Его легко установить через меню Инструменты → Менеджер дополнений. A2plus находится в стадии активной разработки и будет часто получать новые функции. Поэтому вы должны регулярно обновлять его, используя меню Инструменты → Менеджер дополнений. Код A2plus размещается и разрабатывается на GitHub, а также может быть установлен вручную путем копирования его в каталог MOD FreeCAD.

Начало работы

Сначала переключитесь на панель инструментов A2plus во FreeCAD. Для создания сборки создайте новый файл в FreeCAD. Сначала этот файл нужно сохранить. Рекомендуется (но не обязательно) сохранять его в той же папке, что будущая сборка деталей.

Теперь детали можно добавлять в сборку с помощью кнопки на панели инструментов A2p ImportPart.svg или A2p ShapeReference.svg. Кнопка A2p ImportPart.svg добавляет все тела в выбранном файле как единую деталь. При использовании кнопки A2p ShapeReference.svg Вы можете выбрать, какие детали из файла должны быть импортированы как деталь. Так можно, например, импортировать только эскиз для сборки дальнейших частей, используя эскиз для определения позиций деталей.

Первая добавленная часть получает фиксированную позицию по умолчанию. (Это можно изменить позже через свойство детали Dataфиксированная позиция.)

Детали, уже находящиеся в сборке, можно клонировать с помощью кнопки на панели инструментов A2p DuplicatePart.svg.

Чтобы отредактировать деталь из сборки, выберите ее в дереве модели и используйте кнопку на панели инструментов A2p EditPart.svg. Это откроет деталь в новой вкладке во FreeCAD или переключится на ее вкладку, если файл уже открыт.

Чтобы импортировать изменения деталей в сборку, нажмите кнопку на панели инструментов A2p ImportPart Update.svg. Кнопка на пранели A2p RecursiveUpdate.svg тоже импортирует детали, но по возможности рекурсивно подсборки. Если Вы выберете одну или несколько частей в древе проекта FreeCAD, A2plus запросит Вас об обновлении только выбранных частей.

Импортированные части сохранят свои внешние зависимости и могут быть отредактированы. Однако для стандартных частей, таких как винты, полезно, чтобы их форму нельзя было редактировать. Это может быть достигнуто с помощью кнопки на панели инструментов A2p ConvertPart.svg, которая преобразует выбранную деталь в статическую копию оригинальной детали.

Чтобы сохранить сборку и затем закрыть ее, можно использовать кнопку на панели инструментов A2p Save and exit.svg.

Сборка

Сборка деталей осуществляется путем добавления ограничений между деталями. После введения ограничения A2plus переместит детали в соответствии с ограничением, если это возможно.

Ограничения между деталями добавляются удерживанием клавиши Ctrl и выбором ребра или грани двух частей. Затем нажмите кнопку на панели инструментов нужного ограничения. Появится диалог, определённый в разделе Constraints. Ограничение будет добавлено в дереве модели к выделенным деталям.

Для сложных ограничений между частями A2plus может не справится с расположением деталей. Поэтому также ознакомьтесь с разделом Устранение неполадок, чтобы узнать, как решить такие случаи.

Отслеживание

Чем больше частей вы добавляете, тем важнее сохранять возможность их отслеживания. A2plus предлагает следующие инструменты для перемещения и просмотра деталей:

  • Чтобы переместить деталь в сборке, выберите ее в дереве модели и используйте кнопку на панели инструментов A2p MovePart.svg. Когда вы разместите деталь там, где вам это нравится, щелкните левой кнопкой мыши. Если перемещенная деталь уже имеет ограничения, она будет размещена соответствующим образом при нажатии кнопки на панели инструментов A2p solver.svg, потому что это инициирует разрешение всех ограничений сборки.
  • Чтобы отобразить ограничение, выберите его в дереве модели и используйте кнопку на панели инструментов A2p ViewConnection.svg. Это сделает всю сборку прозрачной и выделит два объекта, связанных ограничениями. Чтобы вернуться к обычному виду, щелкните левой кнопкой мыши по сборке.
  • Чтобы показать только определенные детали в сборке, выберите эти детали в дереве модели и используйте кнопку на панели инструментов A2p Isolate Element.svg. В качестве альтернативы вы можете скрыть определенную деталь, выбрав ее в дереве модели и нажав Space, чтобы переключить ее видимость.
  • Для переключения вида прозрачности всей сборки вы можете использовать кнопку панели инструментов A2p ToggleTransparency.svg.
  • Каждая деталь может быть сделана прозрачной при использовании обычного редактирования FreeCAD. Однако, иногда установки прозрачности деталей пропадают при повторном открытии сборки из-за ошибки в FreeCAD. В качестве обходного пути можно использовать кнопку на панели A2p Restore Transparency.svg для восстановления установок прозрачности.

Ограничения

При создании ограничения, после нажатия кнопки на панели инструментов ограничения, будет отображаться такой диалог:

A2p ConstraintPropertiesDialog.png

Выше: Диалог параметров ограничений A2plus


Для определенных ограничений это позволяет вам изменить направление ограничения. С помощью кнопки A2p solver.svg Solve вы можете заранее проверить, может ли это новое ограничение быть решено с помощью A2plus. Если нет, загляните в раздел Разрешение проблем.

Ограничения могут быть сброшены изменением их видимости. Это делается выбором ограничения в древе проекта и нажатием Space. Это переключает свойство DataSuppressed (подавлено). Подавленное ограничение не учитывается при разрешении сборки.

A2plus поддерживает следующие ограничения:

Точка на точке

Выберите Вершины (точки) в каждой детали. Кнопка на панели инструментов A2p PointIdentity.svg добавляет ограничение pointIdentity. Это сделает точки совпадающими.

Точка на линии

Выберите вершину (точку), или край окружности (выберет ее центр), или поверхность сферы (также выберет ее центр) и край детали. Кнопка на панели инструментов A2p PointOnLineConstraint.svg добавляет ограничение pointOnLine. Это поместит точку на край.

Точка на плоскости

Выберите вершину (точку), или край окружности (выберет ее центр), или поверхность сферы (также выберет ее центр) и плоскость. Кнопка на панели инструментов A2p PointOnPlaneConstraint.svg добавляет ограничение pointOnPlane. Диалог ограничений позволяет указать смещение между точкой и плоскостью. Это смещение также можно переключать между обеими сторонами плоскости. Если смещение равно нулю, ограничение поместит вершину на плоскость.

Сфера на Сфере

Выберите поверхность сфер или вершины (точки) на обеих деталях. Кнопка на панели инструментов A2p SphericalSurfaceConstraint.svg добавляет ограничение phereCenterIdent. Это совместит центры сфер, центр сферы и точку, либо вершины.

Круговая кромка на круговой кромке

Выберите край окружности на обеих деталях. Кнопка на панели инструментов A2p CircularEdgeConstraint.svg добавляет ограничение roundEdge. Диалог ограничений позволяет указать смещение между краями. Это смещение также можно перевернуть. Кроме того, вы можете установить направление ограничения и заблокировать вращение частей. Если смещение равно нулю, ограничение поместит края окружности в одной плоскость.

Совпадение по оси

Выберите поверхность сферы или края линий на обеих частях. Кнопка на панели инструментов A2p AxialConstraint.svg добавляет ограничение axisCoincident. Диалог ограничений позволяет указать направление оси. Диалог позволяет вам также заблокировать вращение частей. Ограничение сделает оси или линии совпадающими.

Параллельные оси

Выберите поверхность сферы или края линий на обеих частях. Кнопка на панели инструментов A2p AxisParallelConstraint.svg добавляет ограничение axisParallel. Диалог ограничений позволяет указать направление оси. Ограничение сделает оси или линии параллельными.

Ось параллельно плоскости

Выберите цилиндрическую поверхность или линейные края детали и плоскость на другой детали. Кнопка на панели инструментов A2p AxisPlaneParallelConstraint.svg добавляет ограничение axisPlaneParallel. Ограничение сделает ось или линию параллельной плоскости.

Ось нормально плоскости

Выберите цилиндрическую поверхность или линейные края детали и плоскость на другой детали. Кнопка на панели инструментов A2p AxisPlaneNormalConstraint.svg добавляет ограничение axisPlaneNormal. Ограничение сделает ось или линию нормальной плоскости.

Ось под углом к плоскости

Выберите цилиндрическую поверхность или линейные края детали и плоскость на другой детали. Кнопка панели инструментов A2p AxisPlaneAngleConstraint.svg добавляет ограничение axisPlaneAngle. Это ограничение сначала сделает оси параллельными плоскости. Затем вы можете отрегулировать угол для оси в появившемся диалоговом окне настроек ограничения.

Плоскости Параллельны

Выберите две плоскости. Кнопка на панели инструментов A2p PlanesParallelConstraint.svg добавляет ограничение planesParallel. Диалог ограничений позволяет вам указать направление ограничения. Ограничение сделает плоскости параллельными.

Плоскость на Плоскости

Выберите две плоскости. Кнопка на панели инструментов A2p PlaneCoincidentConstraint.svg добавляет ограничение planeCoincident. Диалог ограничений позволяет указать направление ограничения и смещение между плоскостями. Это смещение также можно перевернуть. Если смещение равно нулю, ограничение сделает плоскости совпадающими.

Плоскость под углом

Выберите две плоскости. Кнопка на панели инструментов A2p AngleConstraint.svg добавляет ограничение angledPlanes. Диалог ограничений позволяет указать угол между плоскостями. Ограничение сначала сделает плоскости параллельными и установит из под заданным углом.

Совпадение в Центре масс

Выберите либо две замкнутые области, либо две плоскости. Кнопка на панели инструментов A2p CenterOfMassConstraint.svg добавляет ограничение centerOfMass. Диалог ограничений позволяет указать смещение между краями или плоскостями. Это смещение также можно перевернуть. Кроме того, вы можете установить направление ограничения и заблокировать вращение частей. Если смещение равно нулю, ограничение поместит области или плоскости в одну плоскость.

Узлы сборки

Сборка может содержать другие сборки. Они добавляются как детали путем нажатия кнопки на панели инструментов A2p ImportPart.svg и выбора файла * .FCStd, содержащего сборку. Такие узлы также можно редактировать как детали, используя кнопку на панели инструментов A2p EditPart.svg. Убедитесь, что для более высоких этапов сборки вы обновили сборку рекурсивно с помощью кнопки на панели инструментов A2p RecursiveUpdate.svg, когда произошли изменения.

Обработка ограничений

Возможные ограничения для выбора отображаются на панели инструментов и в диалоговом окне «Инструменты ограничения» при включении соответствующих кнопок. Диалоговое окно «Инструменты ограничения» открывается с помощью кнопки панели инструментов A2p DefineConstraints.svg. Он должен оставаться открытым, чтобы можно было быстро добавить несколько ограничений в сборку.

Существующие ограничения можно отредактировать, выбрав их в дереве модели, а затем дважды щелкнув по нему или нажав кнопку на панели инструментов A2p EditConstraint.svg. Откроется диалоговое окно «Свойства ограничения».

Ограничения могут быть временно отключены выделением их в древе модели и изменением у элемента параметра DataSuppressed.

Ограничения можно удалить, выбрав их в дереве модели и нажав Del, или выбрав деталь с ограничениями в дереве модели и нажать кнопку на панели инструментов A2p DeleteConnections.svg.

Все ограничения могут быть разрешены в любое время с помощью кнопки на панели инструментов A2p solver.svg. Если кнопка панели инструментов A2p ToggleAutoSolve.svg включена, разрешение выполняется автоматически после каждого редактирования ограничения.

Кнопка на панели инструментов A2p FlipConstraint.svg влияет на ограничение, которое было недавно добавлено. Это переворачивает направление ограничения.

Списки деталей

Чтобы создать списки деталей сборок, разные детали сборки должны получить информацию о детали, которая может быть прочитана A2plus. Это делается путем редактирования детали с помощью кнопки на панели инструментов A2p EditPart.svg. В открывшейся части нажмите кнопку панели инструментов A2p PartsInfo.svg и электронная таблица с именем #PARTINFO#.

Структура электронной таблицы выглядит следующим образом:

A2p PartinfoTable.png

Заполните серые поля имеющейся информацией. Эта информация будет отображена в окончательном списке деталей.

В сборке или узле сборки используйте кнопку на панели инструментов A2p PartsList.svg. Он спросит вас, хотите ли вы выполнить рекурсивную итерацию по всем узлам сборки. Нажмите «Да». Это создаст новую электронную таблицу с именем #PARTSLIST#. Он содержит информацию из различных электронных таблиц деталей PARTSINFO# в списке вида:

A2p PartslistTable.png

Положение (POS) автоматически устанавливается в соответствии с внешним видом деталей в дереве модели. Часть верхнего уровня получит POS 1.

Количество (QTY) автоматически рассчитывается из сборки. Если деталь в сборке дважды, то QTY будет равно 2.

Если вы обновили информацию о детали, вы можете обновить список деталей, снова нажав кнопку на панели инструментов A2p PartsList.svg.

Для сборочных узлов вы также можете создать информационную электронную таблицу с помощью кнопки на панели инструментов A2p PartsInfo.svg. Когда вы создаете или обновляете список деталей главной сборки, эта информация будет использоваться, если вы ответите «Нет» на вопрос, хотите ли вы рекурсивно выполнять итерации по всем узлам сборки. Тогда разные детали будут находится не в списке деталей, а только в узлах сборки.

Специальные возможности

Структура сборки

Кнопка на панели инструментов A2p Treeview.svg создает файл HTML со структурой вашей сборки. Файл по умолчанию будет создан в текущем каталоге вашей сборки. Структура выглядит следующим образом: A2p Dependency-Tree.jpg

Степени свободы

Кнопка A2p DOFs.svg помечает каждую часть сборки степенями свободы. Кроме того, он выводит список со всеми деталями и их зависимостями. Список выводится в виджет FreeCAD «Представление отчета». Если этот виджет в настоящее время не отображается, его можно отобразить, щелкнув правой кнопкой мыши пустую часть области панели инструментов FreeCAD и выбрав его в появившемся контекстном меню, или с помощью меню View → Panels → Просмотр отчета.

Метки степеней свободы можно удалить, повторно нажав кнопку A2p DOFs.svg.

Метки деталей

Кнопка A2p PartLabel.svg присваивает каждой детали сборки в 3D-виде уникальное имя. Метки деталей можно удалить повторно нажав кнопку A2p PartLabelRemove.svg.

Вид всей сборки

Иногда необходимо объединить всю сборку в одну форму. Затем эту форму можно использовать, например, для 3D-печати в Mesh Workbench или для создания чертежей в TechDraw Workbench. Он создается с помощью кнопки панели инструментов A2p SimpleAssemblyShape.svg. Форма по умолчанию не отображается. Используйте ту же кнопку на панели инструментов, чтобы обновить форму в случае изменений в сборке.

Конвертировать абсолютные пути в относительные

С помощью меню A2plus → Misc → A2p SetRelativePathes.svg Convert absolute paths of imported parts to relative ones Вы можете конвертировать абсолютные пути импортированных деталей в относительные.

Настройки

Доступ к настройкам a2plus можно получить через меню FreeCAD Edit → Preferences выбрав раздел «A2plus». Вы можете установить следующие параметры:

Метод решения по умолчанию

Использовать решения частичных систем
Решатель начинает с детали, для которой свойство Dataфиксированная позиция установлено в значение true, а часть ограничена этим. Все остальные части не рассчитываются. Если решение может быть найдено, добавляется следующая часть ограничений для расчета и так далее.
Использовать «магнитный» решатель, решая все детали одновременно
Решатель пытается переместить все детали сразу в направлении к детали, у которой свойство Dataфиксированная позиция установлено в true. Обратите внимание, что в большинстве случаев это займет больше времени для расчета.
Принудительно фиксировать положение
Для всех деталей в сборке свойство Dataфиксированная позиция устанавливается в значение true. Тогда никакие расчеты фактически не выполняются, поскольку все детали всегда будут привязаны к позициям, в которых они были созданы.

Поведение решателя по умолчанию

Решить автоматически, если изменён параметр ограничения
Решатель будет запущен автоматически. Аналогично включению кнопки на панели инструментов A2p ToggleAutoSolve.svg.

Поведение при обновлении импортированных деталей

Пересчитать импортированные детали перед их обновлением
Все детали сборки, включая узлы сборок, будут открыты в FreeCAD для реконструкции с использованием значений из электронных таблиц.
Эта функция предназначена для полного параметрирования конструкции. Примечание: Эта функция очень экспериментальная и не рекомендуется для важных проектов.
Известные проблемы:
  • Сборка может быть уничтожена из-за неправильных ссылок на топологические имена в деталях
  • Основные электронные таблицы могут быть повреждены, когда они редактируются, а файл детали уже закрыт. Это может привести к краху FreeCAD.
Включить рекурсивное обновление импортированных деталей
Открывает все узлы сборки рекурсивно для их обновления.
Использовать экспериментальное топологическое именование
При импорте деталей в сборку алгоритм генерирует топологические имена для каждого узла сборки импортируемой фигуры. Топологические имена записываются в Datamux Info. Когда импортируемая деталь должна быть обновлена, эти топологические имена используются для обновления подэлементов ограничений. Таким образом, сборки становятся более устойчивыми к изменчивым числам подэлементов в FreeCAD.
'Примечание:' Это увеличивает размеры файлов и время расчета при импорте деталей. Если необходимо использовать топологическое именование, оно должно быть активировано до создания сборки.
Наследовать прозрачность для каждой поверхности из деталей и узлов
Использовать настройки цвета и прозрачности из импортированных деталей.
Примечание: Эта функция очень экспериментальная и не рекомендуется для важных проектов.
Не импортировать невидимые фигуры
Это позволит скрыть невидимые базовые / строительные фигуры. Примечание: Никакие ограничения не должны быть связаны с опорными / конструктивными формами в вышестоящих или других сборочных узлах. В противном случае вы можете сломать сборку.
Использовать сплошное объединение для импорта деталей и сборочных узлов
Все импортированные детали будут напрямую объединены в объединение.
Эта функция полезна для моделирования FEM или 3D-печать, если разрешено только одно тело. Альтернативой является создание вида всей сборки позже.

Настройки интерфейса пользователя

Показать ограничения на панели инструментов
Если эта опция не используется, кнопки панели инструментов для различных ограничений не видны, чтобы сэкономить место на панели инструментов. Новые ограничения по-прежнему можно установить с помощью диалогового окна «Инструменты ограничения» (кнопка на панели инструментов A2p DefineConstraints.svg).

Хранение файлов

Использовать относительные пути для импортированных деталей
Использует относительные пути к файлам деталей.
Использовать абсолютные пути для импортированных деталей
Использует абсолютные пути к файлам деталей.
Все файлы находятся в этой папке проекта
Все файлы проекта должны находиться в указанной папке. Не имеет значения, находятся ли они в подпапках этой папки. 'Примечание:' Одинаковые файлы не могут присутствовать несколько раз в папке (например, в разных подпапках).
Эта опция полезна для работы на разных машинах, потому что тогда нужно только скопировать папку проекта.

Разрешение проблем

Рано или поздно у вас возникнет проблема, что A2plus не может решить установленные вами ограничения. Чтобы преодолеть это, существуют разные стратегии:

Using the Conflict Finder Tool

This is the safest method when you have several constraints because this tool attempts to solve one constraint after another until it finds the conflicting constraint. Then you can go on with the other strategies to resolve the identified constraint. The tool is called using the toolbar button A2p SearchConstraintConflicts.svg.

Checking Constraint Direction

Иногда кажется, что ограничения определены последовательно, но они, тем не менее, не могут быть решены. Пример: Предположим, у вас есть ограничение planesParallel для двух плоскостей. Теперь вы хотите установить для этих же плоскостей ограничение planeCoincident, и A2plus не может решить эту проблему. Тогда направления ограничений planesParallel и planeCoincident различны. Используйте одно и то же направление для обоих ограничений, чтобы исправить это.

A2plus предлагает автоматическую проверку правильных направлений для всех ограничений, используя кнопку панели инструментов A2p ReAdjustConstraints.svg.

Удаление ограничений

Большинство случаев неразрешимых ограничений происходит непосредственно при добавлении нового ограничения. Решение состоит в том, чтобы удалить ограничение, которое вы добавили последним. A2plus также предложит это.

Иногда стратегия удаления является единственной, например, когда вы отредактировали деталь в FreeCAD так, что грани или ребра, связанные с ограничениями, отсутствуют. Затем следует удалить ограничение по одному, которое связано с измененной деталью. Используйте кнопку на панели инструментов A2p solver.svg после каждого удаления, чтобы увидеть, достигли ли вы разрешимого состояния.

Когда вы получите сборку, которую можно решить, добавьте шаг за шагом необходимые ограничения.

Перемещение деталей

В некоторых случаях решателю нужны только лучшие начальные значения для решения ограничений. Возьмем, к примеру, случай, когда у вас есть осевая часть и колесная часть. Вы добавляете ограничение axisCoincident и не получаете информации о том, что решатель не выполнен, но части не перемещаются соответствующим образом, и в виджете «Представление отчета» FreeCAD вы видите "REACHED POS-ACCURACY: 0.0". Решением для этого является перемещение деталей ближе к той позиции, которую вы хотите получить с помощью ограничения.

Примечание: Убедитесь, что хотя бы для одной части ограничения свойство Data фиксированная позиция установлено в значение false.

Настройка свойства Tip

Если вы пропустили некоторые функции своей детали после импорта в сборку A2plus, проверьте свойство DataTip.

A2plus импортирует тела деталей со всеми их функциями вплоть до свойства Tip. Это разумно, потому что установка Tip на определенную функцию означает, что все функции после Tip не должны появляться в итоговой детали. Так что если Вы пропустили функцию детали в A2plus, откройте деталь через кнопку панели инструментов A2p EditPart.svg, выделите тело и посмотрите свойство DataTip. Если это свойство не в той функции, где нужно, сделайте правый клик на функции, где оно должно быть и выберите PartDesign MoveTip.svg Set tip.Затем сохраните деталь и перезагрузите сборку с помощью кнопки на панели инструментов A2p ImportPart Update.svg.

Восстановление дерева сборки

Если вы не видите четкой причины, по которой некоторые ограничения не могут быть разрешены, вы можете попробовать использовать кнопку на панели инструментов A2p RepairTree.svg. Это разрешит все ограничения и снова сгруппирует их по разным частям.

Перенос старых сборок A2plus

Сборки, созданные с A2plus старше марта 2019 года, не показывают правильные значки для импортированных деталей и имеют устаревшие свойства. Эти сборки можно перенести в A2plus версии 0.4.35 и новее, используя меню A2plus → Misc → A2p Upgrade.svg Migrate proxies of imported parts. Сделав это, вы должны сохранить и снова открыть файл сборки.

Избегайте символов подчеркивания

Эта стратегия не нужна для Windows.

В некоторых операционных системах могут возникнуть проблемы, если имена файлов или пути к файлам деталей или сборки содержат символы с подчеркиванием. Поэтому избегайте таких символов, а также специальных символов в целом.

Фиксированная позиция

Эта стратегия больше не нужна для сборок, созданных с использованием A2plus 0.3.11 или новее, поскольку A2plus теперь выдает предупреждение о пропущенных фиксированных позициях.

Когда вы устанавливаете ограничение между двумя деталями, и ни одна деталь не имеет свойств Data фиксированная позиция установленным в true или связано ограничением с деталью с Data фиксированная позиция установленным в true, ограничение не может быть решено. То же самое происходит, если в обеих частях ограничения Data фиксированная позиция установлено значение true.

Затем A2plus выводит информацию о неудачном решении, но иногда вы видите только то, что детали не перемещаются соответствующим образом, и в виджете «Представление отчета» FreeCAD вы видите «REACHED POS-ACCURACY: 0.0». Это означает, что решатель завершил работу без ошибок, но на самом деле он не смог решить ограничения.

Поэтому убедитесь, что хотя бы для одной из ваших деталей в сборке Dataфиксированная позиция установлено значение true. Затем убедитесь, что вы устанавливаете ограничения только для детали, которая каким-то образом связана с фиксированной деталью. Чтобы визуализировать эти зависимости, см. Раздел Структура сборки.

Вращение деталей

Эта стратегия больше не требуется для сборок, созданных с использованием A2plus 0.4.0 или новее, поскольку A2plus автоматически поворачивает детали в фоновом режиме, чтобы получить достаточный начальный угол для решателя.

Решатель часто не выполняется для ограничения angledPlanes, если две выбранные плоскости в настоящее время имеют угол 0 ° или 180 °. (Части не перемещаются соответственно, и в виджете «Просмотр отчета» FreeCAD вы видите «REACHED POS-ACCURACY: 0.0».) Решение этой проблемы - повернуть одну часть на несколько градусов с помощью FreeCAD функция преобразования (щелкните правой кнопкой мыши деталь в дереве модели и выберите в контекстном меню Transform).

Примечание: Убедитесь, что хотя бы для одной части ограничения свойство Data фиксированная позиция установлено в значение false.

Анимация

A2plus предлагает анимацию с помощью перетаскивания и скриптов Python.

Перетаскиванием

Анимация перетаскиванием интерактивна, поскольку вы запускаете её, перетаскивая часть сборки. Чтобы получить этот тип анимации:

  1. Полностью ограничьте деталь, движение или вращение которой нужно анимировать.
  2. Нажмите на кнопку панели инструментов A2p MovePartUnderConstraints.svg. Это включает режим перетаскивания.
  3. Нажмите на нужную деталь в сборке.
  4. Теперь вы можете перемещать мышь, и деталь будет следовать за движением мыши в пределах установленных ограничений.
  5. Чтобы завершить режим перетаскивания, щелкните левой кнопкой мыши в сборке или нажмите ESC.

Вот пример сборки, чтобы попробовать анимацию перетаскиванием: A2p_example-for-dragging-animation.FCStd

A2p dragging-animation-result.gif

Выше: анимация перетаскивания с использованием примера сборки


Скриптами

Хотя режим перетаскивания предлагает приятные интерактивные анимации, они порой недостаточно точны для скринкастов или видео. Скриптовые анимации имеют то преимущество, что они анимируют движения и вращения определенным образом. Например, вы можете повернуть деталь ровно на 10° назад и вперед. В следующих примерах используется сборка, в которой деталь должна вращаться. Если вы попытаетесь анимировать это с помощью режима перетаскивания, вы увидите, как трудно получить вращение вперед-назад, чтобы, например, показать своему боссу в презентации. С помощью интерактивного сценарного примера, в то же время, это простая задача.

Скриптовая анимация обычно работает следующим образом:

  1. Сборку полностью ограничивают
  2. Сценарий изменяет параметр, например, положение или угол поворота детали.
  3. После изменения параметра разрешаются ограничения сборки
  4. Шаг 2. и 3. повторяются, чтобы получить анимацию.

Также можно изменить вместо параметра размещения ограничение, например, расстояние между двумя плоскостями.

Пример простого скрипта

Самый простой способ написать сценарий анимации - это неинтерактивная анимация, которая следует заданному движению. Вот пример: Сначала скачайте этот сборочный файл A2p_animated-example.FCStd и этот скрипт Python A2p_animation-example-script.py.

Вот содержимое скрипта. Строки, начинающиеся с «#», описывают, что делают его разные строки:

# импорт библиотек
import time, math, PySide
import A2plus.a2p_solversystem as a2p_solver

# используем шаг в 1 градус
step = 1
# ждём 1 ms между шагами
timeout = 0.001
# начальный угол будет 0 градусов
angle = 0
# берём текущий открытый документ
document = FreeCAD.activeDocument()
# далее мы хотим менять угол вращения детали "star_wheel_001"
starWheel = document.getObject("star_wheel_001")
# определяем диалог хода выполнения от 0 до 360
progressDialog = PySide.QtGui.QProgressDialog(u"Animation progress", u"Stop", 0, 360)

# блок while является основным циклом для изменения угла и 
# разрешения ограничений сборки пошагово
while angle < 360: # запускает цикл пока мы не выполним полный оборот (360 градусов)
    # прибавляем угол вращения
    angle += step
    # устанавливаем новый угол в диалоге хода выполнения
    progressDialog.setValue(angle)
    # изменение угла вращения детали "star_wheel_001"
    starWheel.Placement.Rotation.Angle = math.radians(angle)
    # разрешение ограничений
    a2p_solver.solveConstraints(document, useTransaction=True)
    # обновление вида после разрешения ('Gui' здесь графический интерфейс)
    FreeCADGui.updateGui()
    # вынесение диалога хода выполнения на первый план
    PySide.QtGui.QWidget.raise_(progressDialog)
    # если будет нажата кнопка 'Stop', выйти из цикла
    if progressDialog.wasCanceled():
        angle = 360
    # сделать паузу перед следующим шагом
    time.sleep(timeout)

Чтобы использовать скрипт для выполнения анимации, мы должны

  1. Открыть файл сборки в FreeCAD.
  2. Открыть файл скрипта во FreeCAD.
  3. Кликнуть кнопку на панели инструментов Menu Std DlgMacroExecute fr 02.png для запуска скрипта (так же называемого макрос).
  4. Перейти на вкладку со сборкой для наблюдения за вращением.

Измените что-нибудь в скрипте для практики и запустите снова. Например, измените step на 5.

Вот результат анимации примера:

A2p animated-example-result.gif

Пример интерактивного скрипта

Пример первого скрипта показывает создание анимации без вмешательства пользователя. Для большинства приложений Вам нужно вмешиваться в ход анимации. Например, интересный момент в примере - посмотреть как ведущие штифты пересекают центральную канавку колеса. Для более внимательного просмотра Вам следует представить эту деталь коллегам или начальнику. Поэтому вам нужно интерактивное решение.

Это может быть сделано использованием пользовательского диалога анимации со слайдером. Перемещая слайдер, Вы можете установить угол вращения и вращать вперёд и назад в интересующей позиции.

Мы используем тот же файл сборки A2p_animated-example.FCStd, и другой скрипт Python A2p_animation-example-script.py.

Вот содержимое скрипта для получения диалога интерактивной анимации:

# импорт библиотек
import time, math, PySide, sys
import FreeCAD.A2plus.a2p_solversystem as a2p_solver
from FreeCAD import Units
from PySide import QtCore, QtGui

# ждать 1 мс после каждого вычисления
timeout = 0.001
# мы берём текущий открытый документ
document = FreeCAD.activeDocument()
# нам нужно впоследствии изменять угол вращения детали "star_wheel_001"
starWheel = document.getObject("star_wheel_001")

class AnimationDlg(QtGui.QWidget): # диалог анимации

    def __init__(self): # для инициализации диалога
        super(AnimationDlg, self).__init__()
        self.initUI()

    def initUI(self): # the definition of the dialog components
        self.setMinimumSize(self.minimumSizeHint()) # set the minimal dialog size to minimum
        self.setWindowTitle('Animation Dialog')
        # use a grid layout for the whole form
        self.mainLayout = QtGui.QGridLayout()
        self.lineNo = 0 # first dialog grid line
        # add description label
        DescriptionLabel = QtGui.QLabel(self)
        DescriptionLabel.setText("Change slider to change rotation angle")
        self.mainLayout.addWidget(DescriptionLabel,self.lineNo,0,1,4)
         # next dialog grid line
        self.lineNo += 1
        # add a label; there is no need for the "self." prefix because we don't want to change the label later
        LabelMin = QtGui.QLabel(self)
        LabelMin.setText("Min")
        LabelMin.setFixedHeight(32)
        self.mainLayout.addWidget(LabelMin,self.lineNo,0)
        # add a spin edit to define the slider minimum
        self.MinEdit = QtGui.QSpinBox(self)
        # get the angle unit as string
        self.MinEdit.setSuffix(" " + str(FreeCAD.Units.Quantity(1, FreeCAD.Units.Angle))[2:])
        self.MinEdit.setMaximum(999)
        self.MinEdit.setMinimum(0)
        self.MinEdit.setSingleStep(10)
        self.MinEdit.setValue(0)
        self.MinEdit.setFixedHeight(32)
        self.MinEdit.setToolTip("Minimal angle for the slider")
        QtCore.QObject.connect(self.MinEdit, QtCore.SIGNAL("valueChanged(int)"), self.setMinEdit)
        self.mainLayout.addWidget(self.MinEdit,self.lineNo,1)
        # add the slider
        self.slider = QtGui.QSlider(QtCore.Qt.Horizontal, self)
        self.slider.setRange(0, 360)
        self.slider.setValue(0)
        self.slider.setFixedHeight(32)
        self.slider.setToolTip("Move the slider to change the rotation angle")
        QtCore.QObject.connect(self.slider, QtCore.SIGNAL("sliderMoved(int)"), self.handleSliderValue)
        self.mainLayout.addWidget(self.slider,self.lineNo,2)
        # add a label
        LabelMax = QtGui.QLabel(self)
        LabelMax.setText("Max")
        LabelMax.setFixedHeight(32)
        self.mainLayout.addWidget(LabelMax,self.lineNo,3)
        # add a spin edit to define the slider maximum
        self.MaxEdit = QtGui.QSpinBox(self)
        # get the angle unit as string
        self.MaxEdit.setSuffix(" " + str(FreeCAD.Units.Quantity(1, FreeCAD.Units.Angle))[2:])
        self.MaxEdit.setMaximum(999)
        self.MaxEdit.setMinimum(1)
        self.MaxEdit.setSingleStep(10)
        self.MaxEdit.setValue(360)
        self.MaxEdit.setFixedHeight(32)
        self.MaxEdit.setToolTip("Maximal angle for the slider")
        QtCore.QObject.connect(self.MaxEdit, QtCore.SIGNAL("valueChanged(int)"), self.setMaxEdit)
        self.mainLayout.addWidget(self.MaxEdit,self.lineNo,4)
         # next dialog grid line
        self.lineNo += 1
        # add a spacer
        self.mainLayout.addItem(QtGui.QSpacerItem(10,10), 0, 0)
        # add a label
        LabelCurrent = QtGui.QLabel(self)
        LabelCurrent.setText("Current angle:")
        LabelCurrent.setFixedHeight(32)
        self.mainLayout.addWidget(LabelCurrent,self.lineNo,1)
        # output the current angle
        self.CurrentAngle = QtGui.QLineEdit(self)
        self.CurrentAngle.setText(str(0))
        self.CurrentAngle.setFixedHeight(32)
        self.CurrentAngle.setToolTip("Current rotation angle")
        self.CurrentAngle.isReadOnly()
        self.mainLayout.addWidget(self.CurrentAngle,self.lineNo,2)
        # add label for the unit
        LabelUnit = QtGui.QLabel(self)
        LabelUnit.setText("deg")
        LabelUnit.setFixedHeight(32)
        self.mainLayout.addWidget(LabelUnit,self.lineNo,3)
        # button to close the dialog
        self.Close = QtGui.QPushButton(self)
        self.Close.setText("Close")
        self.Close.setFixedHeight(32)
        self.Close.setToolTip("Closes the dialog")
        QtCore.QObject.connect(self.Close, QtCore.SIGNAL("clicked()"), self.CloseClicked)
        self.mainLayout.addWidget(self.Close,self.lineNo,4)
        # place the defined grid layout to the dialog
        self.setLayout(self.mainLayout)
        self.update()

    def handleSliderValue(self):
        # set slider value as angle
        starWheel.Placement.Rotation.Angle = math.radians(self.slider.value())
        # output current angle
        self.CurrentAngle.setText(str(self.slider.value()))
        # solve the constraints 
        a2p_solver.solveConstraints(document)
        # update the view after the solving ('Gui' stands for 'graphical user interface')
        FreeCADGui.updateGui()
        # wait some time, important to give time to perform calculations
        time.sleep(timeout)

    def setMinEdit(self):
        # assure that the minimum is samller than the maximum
        if self.MinEdit.value() >=  self.MaxEdit.value():
            self.MaxEdit.setValue(self.MinEdit.value() + 1)
        self.slider.setRange(self.MinEdit.value(), self.MaxEdit.value())

    def setMaxEdit(self):
        # assure that the minimum is samller than the maximum
        if self.MinEdit.value() >=  self.MaxEdit.value():
            self.MinEdit.setValue(self.MaxEdit.value() - 1)
        self.slider.setRange(self.MinEdit.value(), self.MaxEdit.value())

    def CloseClicked(self):
        AnimationDialog.close()

# создать и показать определённый выше диалог
AnimationDialog = AnimationDlg()
AnimationDialog.show()

# запустить цикл когда диалог станет видим
while AnimationDialog.isVisible():
    # обновить вид, важно чтобы дать обратную связь ОС для оживления диалога
    FreeCADGui.updateGui()
    # вынесение диалога вперёд, чтобы он был всегда видим
    QtGui.QWidget.raise_(AnimationDialog)
    # здесь так же выводится выходного ползунка, поскольку во время вычисления слайдер мог быть передвинут
    AnimationDialog.CurrentAngle.setText(str(AnimationDialog.slider.value()))

Диалог, определенный в скрипте, выглядит следующим образом:

A2p AnimationDialog.png

Script Commands

Чтобы лучше понять синтаксис скрипта, вот некоторая информация о команде:

starWheel.Placement.Rotation.Angle = math.radians(angle)

Здесь мы меняем свойство размещения Rotation.Angle детали, которая была преждде взята как starWheel. Это свойство даёт угол в радианах. Функция radians() из библиотеки math преобразует угол из градусов в радианы.

Свойство Rotation.Angle использует текущее размещение осей детали (в нашем примере ось X). Для вращения детали, например, вокруг оси Z, надо установить ось вращения (перед вызовом команды вращения), используя команду:

starWheel.Placement.Rotation.Axis = FreeCAD.Vector(0,0,1)

Вместо вращения деталь может перемещаться. Чтобы изменить, например, размещение в направлении оси Y оси, команда должна быть:

starWheel.Placement.Base.y = PositionShift

В этом случае мы должны определять не переменную angle, а PositionShift, которую мы меняем каждый проход цикла.

Существуют разные способы установки размещения детали. Некоторые документированы здесь. К сожалению, списка со всеми возможными командами размещения не существует (пока).

a2p_solver.solveConstraints(document, useTransaction=False/True)

Это специфичная для A2plus команда. Она разрешает сборочные ограничения сборки, которую мы ранее получили как document. Опция useTransaction указывает, если FreeCAD должен сохранять каждое изменение в стеке отмены/повтора. Поэтому для долгой анимации Вам следует установить её в false.